package org.clank.support.aliases;

import org.clank.support.Converted;
import org.clank.support.*;
import static org.clank.support.NativeType.*;
import static org.clank.support.NativeMemory.*;
import static org.clank.support.NativePointer.*;

/**
 * Heavy implementation of pointer to ${TYPE}
 */
//<editor-fold defaultstate="collapsed" desc="template">
@Converted(kind = Converted.Kind.DUMMY, source = "${SPUTNIK}/modules/org.clank.java/src/org/clank/support/aliases/templates/pointerheavyimpl.tpl")
//</editor-fold>
public class ${FILE_NAME}${CLASS_SUFFIX} extends AbstractHeavyPointerType<${POINTER_NAME}, ${MEMORY_NAME}> implements ${POINTER_NAME} {

    public ${FILE_NAME}(${TYPE} value) {
        this(new ${MEMORY_IMPL}(value), 0, null, 0);
    }

    public ${FILE_NAME}(${TYPE}[] values) {
        this(new ${MEMORY_IMPL}(values), 0, null, 0);
    }

    public ${FILE_NAME}(${TYPE}[] values, long index) {
        this(new ${MEMORY_IMPL}(values), index, null, 0);
    }
    public ${FILE_NAME}(${TYPE}[] values, int index) {
        this(new ${MEMORY_IMPL}(values), index, null, 0);
    }
    
    public ${FILE_NAME}(${MEMORY_NAME} values) {
        this(values, 0, null, 0);
    }

    public ${FILE_NAME}(${MEMORY_NAME} values, long index) {
        this(values, index, null, 0);
    }        
    public ${FILE_NAME}(${MEMORY_NAME} values, int index) {
        this(values, index, null, 0);
    }        
    
    public ${FILE_NAME}(${MEMORY_NAME} values, long index, type$memory<${POINTER_NAME}> selfMemory, int selfIndex) {
        super(values, Unsigned.long2uint(index), selfMemory, selfIndex);
    }
    public ${FILE_NAME}(${MEMORY_NAME} values, int index, type$memory<${POINTER_NAME}> selfMemory, int selfIndex) {
        super(values, index, selfMemory, selfIndex);
    }

    @Override
    public ${TYPE} $star() {
        return $at(index);
    }

    @Override
    public ${TYPE} $set(${TYPE} value) {
        return $set(0, value);
    }

    @Override
    public ${TYPE} $at(int index) {
        return memory.$at(this.index + index);
    }
    @Override
    public ${TYPE} $at(long index) {
        return memory.$at(this.index + index);
    }

    @Override
    public ${TYPE} $set(int index, ${TYPE} value) {
        return memory.$set(this.index + index, value);
    }
    @Override
    public ${TYPE} $set(long index, ${TYPE} value) {
        return memory.$set(this.index + index, value);
    }
    ${BUILTIN_TYPE_MODIFY_VALUE_SECTION_START}
    @Override
    public ${TYPE} $set$andassign(int index, ${TYPE} value) {
        return memory.$set$andassign(this.index + index, value);
    }
    @Override
    public ${TYPE} $set$andassign(long index, ${TYPE} value) {
        return memory.$set$andassign(this.index + index, value);
    }

    @Override
    public ${TYPE} $set$xorassign(int index, ${TYPE} value) {
        return memory.$set$xorassign(this.index + index, value);
    }
    @Override
    public ${TYPE} $set$xorassign(long index, ${TYPE} value) {
        return memory.$set$xorassign(this.index + index, value);
    }

    @Override
    public ${TYPE} $set$orassign(int index, ${TYPE} value) {
        return memory.$set$orassign(this.index + index, value);
    }
    @Override
    public ${TYPE} $set$orassign(long index, ${TYPE} value) {
        return memory.$set$orassign(this.index + index, value);
    }

    ${BUILTIN_TYPE_MODIFY_VALUE_SECTION_END}${ADDITIONAL_MODIFY_VALUE_SECTION_START}

    @Override
    public ${TYPE} $set$addassign(int index, ${TYPE} value) {
        return memory.$set$addassign(this.index + index, value);
    }
    @Override
    public ${TYPE} $set$addassign(long index, ${TYPE} value) {
        return memory.$set$addassign(this.index + index, value);
    }

    @Override
    public ${TYPE} $set$minusassign(int index, ${TYPE} value) {
        return memory.$set$minusassign(this.index + index, value);
    }
    @Override
    public ${TYPE} $set$minusassign(long index, ${TYPE} value) {
        return memory.$set$minusassign(this.index + index, value);
    }

    @Override
    public ${TYPE} $set$starassign(int index, ${TYPE} value) {
        return memory.$set$starassign(this.index + index, value);
    }
    @Override
    public ${TYPE} $set$starassign(long index, ${TYPE} value) {
        return memory.$set$starassign(this.index + index, value);
    }

    @Override
    public ${TYPE} $set$slashassign(int index, ${TYPE} value) {
        return memory.$set$slashassign(this.index + index, value);
    }
    @Override
    public ${TYPE} $set$slashassign(long index, ${TYPE} value) {
        return memory.$set$slashassign(this.index + index, value);
    }

    @Override
    public ${TYPE} $set$modassign(int index, ${TYPE} value) {
        return memory.$set$modassign(this.index + index, value);
    }
    @Override
    public ${TYPE} $set$modassign(long index, ${TYPE} value) {
        return memory.$set$modassign(this.index + index, value);
    }

    @Override
    public ${TYPE} $set$lshiftassign(int index, ${TYPE} value) {
        return memory.$set$lshiftassign(this.index + index, value);
    }
    @Override
    public ${TYPE} $set$lshiftassign(long index, ${TYPE} value) {
        return memory.$set$lshiftassign(this.index + index, value);
    }

    @Override
    public ${TYPE} $set$rshiftassign(int index, ${TYPE} value) {
        return memory.$set$rshiftassign(this.index + index, value);
    }
    @Override
    public ${TYPE} $set$rshiftassign(long index, ${TYPE} value) {
        return memory.$set$rshiftassign(this.index + index, value);
    }

    @Override
    public ${TYPE} $set$postInc(int index) {
        return memory.$set$postInc(index);
    }
    @Override
    public ${TYPE} $set$postInc(long index) {
        return memory.$set$postInc(index);
    }

    @Override
    public ${TYPE} $set$postDec(int index) {
        return memory.$set$postDec(index);
    }
    @Override
    public ${TYPE} $set$postDec(long index) {
        return memory.$set$postDec(index);
    }

    @Override
    public ${TYPE} $set$preInc(int index) {
        return memory.$set$preInc(index);
    }
    @Override
    public ${TYPE} $set$preInc(long index) {
        return memory.$set$preInc(index);
    }

    @Override
    public ${TYPE} $set$preDec(int index) {
        return memory.$set$preDec(index);
    }
    @Override
    public ${TYPE} $set$preDec(long index) {
        return memory.$set$preDec(index);
    }

    ${ADDITIONAL_MODIFY_VALUE_SECTION_END}

    @Override
    public ${REFERENCE_NAME} star$ref() {
      throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public int $index() {
      throw new UnsupportedOperationException("Not supported; create array based instance instead");
    }

    @Override
    public ${TYPE}[] $array() {
      throw new UnsupportedOperationException("Not supported; create array based instance instead");
    }
}